(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('hash-sum'), require('nanoid/non-secure'), require('@lazy-random/seed-data'), require('@lazy-num/float-to-string'), require('@lazy-random/original-math-random'), require('@lazy-random/shared-lib'), require('@lazy-assert/check-basic')) :
	typeof define === 'function' && define.amd ? define(['exports', 'hash-sum', 'nanoid/non-secure', '@lazy-random/seed-data', '@lazy-num/float-to-string', '@lazy-random/original-math-random', '@lazy-random/shared-lib', '@lazy-assert/check-basic'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.LazyRandomSeedToken = {}, global.hashSum$1, global.nonSecure, global.seedData, global.floatToString, global.originalMathRandom, global.sharedLib, global.checkBasic));
})(this, (function (exports, hashSum$1, nonSecure, seedData, floatToString, originalMathRandom, sharedLib, checkBasic) { 'use strict';

	function hashSum(input, ...argv) {
	  return hashSum$1(input, ...argv);
	}

	// @ts-ignore
	function nanoid(input, ...argv) {
	  // @ts-ignore
	  return nonSecure.nanoid();
	}

	let _name;
	let _version;
	/**
	 * give a random string for create seed
	 */
	function randomSeedStr() {
	  var _name2, _version2;
	  return [nanoid(), (_name2 = _name) !== null && _name2 !== void 0 ? _name2 : _name = hashSum$1(seedData.name), (_version2 = _version) !== null && _version2 !== void 0 ? _version2 : _version = hashSum$1(seedData.version), Date.now(), floatToString.floatToString(originalMathRandom._MathRandom())].join('_');
	}

	function hashAny(seed, ...argv) {
	  if (!seed) {
	    seed = randomSeedStr();
	  } else if (typeof seed !== 'string') {
	    seed = hashSum(seed);
	  }
	  return String(seed);
	}

	function randomSeedNum() {
	  return originalMathRandom._MathRandom() * sharedLib.MATH_POW_2_32 + originalMathRandom._MathRandom();
	}

	function seedToken(seed, opts, ...argv) {
	  // TODO: add entropy and stuff
	  if (checkBasic.isFiniteInt(seed)) {
	    return seed;
	  }
	  const strSeed = String(seed);
	  let s = 0;
	  const len = strSeed.length;
	  for (let k = 0; k < len; ++k) {
	    s ^= strSeed.charCodeAt(k) | 0;
	  }
	  return s;
	}

	exports.default = seedToken;
	exports.hashAny = hashAny;
	exports.hashSum = hashSum;
	exports.nanoid = nanoid;
	exports.randomSeedNum = randomSeedNum;
	exports.randomSeedStr = randomSeedStr;
	exports.seedToken = seedToken;

	Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=index.umd.development.cjs.map
